#pragma semicolon 1
#include <sourcemod>
#include <dodhooks>

new bool:g_GameStarted;

new Handle:g_ConVar_Enabled;
new Handle:g_ConVar_RespawnTime;

public Plugin:myinfo = 
{
	name = "DoD:S Respawn Extender", 
	author = "Andersso", 
	description = "Extends a players respawn time in DoD:S", 
	version = "1.0.0", 
	url = "http://www.dodsplugins.net/"
};

public OnPluginStart()
{
	g_ConVar_Enabled = CreateConVar("sm_respawnextender_enabled", "1", "Enable/Disable DoD:S Respawn Extender.", FCVAR_PLUGIN);
	g_ConVar_RespawnTime = CreateConVar("sm_respawnextender_respawntime", "60.0", "The respawn time of a player.", FCVAR_PLUGIN);
}

public Action:OnEnterRoundState(&roundState)
{
	if (roundState == DoDRoundState_PreGame)
	{
		g_GameStarted = false;
	}
	
	if (roundState == DoDRoundState_StartGame)
	{
		g_GameStarted = true;
	}
}

public Action:OnAddWaveTime(index, &Float:delay)
{
	if (GetConVarBool(g_ConVar_Enabled) && g_GameStarted)
	{
		delay = GetConVarFloat(g_ConVar_RespawnTime);
		
		return Plugin_Changed;
	}
	
	return Plugin_Continue;
}
